(function() {
  var Client, exports;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  exports = this;
  exports.Client = Client = (function() {
    function Client(args) {
      this.args = args;
      this.LERP = 100;
      this.update_messages_by_entity_id = {};
      this.update_entities_messages = [];
      this.queued_messages = [];
      this.entities_by_id = {};
      this.player_entity_id = null;
      this.next_player_command_id = 0;
      this.unacknowledged_player_commands = [];
      this.last_acked_player_state = null;
      this.socket = io.connect('http://localhost', {
        'force new connection': true,
        reconnect: false
      });
      this.socket.on('connect', function() {
        return console.log('connected');
      });
      this.socket.on('message', __bind(function(data) {
        var msg;
        msg = JSON.parse(data);
        return this.queued_messages.push(msg);
      }, this));
      this.socket.on('disconnect', function() {
        return console.log('disconnected');
      });
    }
    Client.prototype.new_frame = function() {
      var entity, id, messages_to_handle, msg, player, prop, val, _i, _j, _len, _len2, _ref, _ref2, _ref3, _ref4;
      _ref = [this.queued_messages, []], messages_to_handle = _ref[0], this.queued_messages = _ref[1];
      for (_i = 0, _len = messages_to_handle.length; _i < _len; _i++) {
        msg = messages_to_handle[_i];
        this.handle_message(msg);
      }
      player = this.player_entity;
      _ref2 = this.last_acked_player_state;
      for (prop in _ref2) {
        val = _ref2[prop];
        player[prop] = val;
      }
      _ref3 = this.unacknowledged_player_commands;
      for (_j = 0, _len2 = _ref3.length; _j < _len2; _j++) {
        msg = _ref3[_j];
        player[msg.command](msg.args);
      }
      _ref4 = this.entities_by_id;
      for (id in _ref4) {
        entity = _ref4[id];
        if (id !== this.player_entity_id) {
          entity.lerp_update(this.render_time);
        }
      }
      return this.render_time = new Date().getTime() - this.gametime_offset - this.LERP;
    };
    Client.prototype.handle_message = function(message) {
      var entity, prop, val, _ref;
      switch (message.message_type) {
        case Percept.Message.MESSAGE_TYPES.ACK:
          return this.on_ack(message);
        case Percept.Message.MESSAGE_TYPES.GAME_INIT:
          this.player_entity_id = message.your_entity_id;
          entity = this.args.create_entity(message.your_entity_id, message.your_entity_state);
          entity.id = message.your_entity_id;
          this.entities_by_id[entity.id] = entity;
          this.player_entity = entity;
          console.log("my ent id " + entity.id);
          _ref = message.your_entity_state;
          for (prop in _ref) {
            val = _ref[prop];
            entity[prop] = val;
          }
          this.last_acked_player_state = message.your_entity_state;
          this.gametime_offset = new Date().getTime() - message.at_gametime;
          return this.render_time = message.at_gametime - this.LERP - this.FAKE_LAG;
        case Percept.Message.MESSAGE_TYPES.UPDATE_ENTITIES:
          return this.update_entities_states(message);
        case Percept.Message.REMOVE_ENTITY:
          return this.remove_entity(message.entity_id);
      }
    };
    Client.prototype.send_message = function(msg) {
      return this.socket.send(JSON.stringify(msg));
    };
    Client.prototype.update_entities_states = function(msg) {
      var entity, id, state, _ref, _results;
      _ref = msg.entity_states_by_entity_id;
      _results = [];
      for (id in _ref) {
        state = _ref[id];
        entity = this.entities_by_id[id];
        if (!entity) {
          entity = this.args.create_entity(id, state);
          this.entities_by_id[id] = entity;
        }
        state.gametime = msg.at_gametime;
        _results.push(entity._received_states.push(state));
      }
      return _results;
    };
    Client.prototype.remove_entity = function(id) {
      this.entities_by_id[id].destroy();
      return delete this.entities_by_id[id];
    };
    Client.prototype.on_ack = function(message) {
      var cmd;
      if (message.command_id) {
        this.unacknowledged_player_commands = (function() {
          var _i, _len, _ref, _results;
          _ref = this.unacknowledged_player_commands;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            cmd = _ref[_i];
            if (cmd.command_id > message.command_id) {
              _results.push(cmd);
            }
          }
          return _results;
        }).call(this);
        return this.last_acked_player_state = message.entity_state;
      }
    };
    return Client;
  })();
}).call(this);
