(function() {
  var exports;
  exports = this;
  exports.Lerpable = function() {
    return {
      _received_states: [],
      lerp_update: function(render_time) {
        var distance_too_great, distance_xy, dont_interpolate, from_state, interpolation_percentage, max_interpolation_distance, offset_time, prop, self, time_between_states, to_state, val, _ref;
        _ref = this.get_states_for_lerping(render_time), from_state = _ref[0], to_state = _ref[1];
        self = this;
        for (prop in from_state) {
          val = from_state[prop];
          self[prop] = val;
        }
        if (!((from_state != null) && (to_state != null))) {
          return;
        }
        max_interpolation_distance = 300;
        distance_xy = [Math.abs(to_state.x - from_state.x), Math.abs(to_state.y - from_state.y)];
        if (distance_xy[0] > max_interpolation_distance || distance_xy[1] > max_interpolation_distance) {
          distance_too_great = true;
        }
        if (distance_too_great) {
          dont_interpolate = true;
        }
        if (dont_interpolate) {
          return interpolation_percentage = 1.0;
        } else {
          offset_time = render_time - from_state.gametime;
          time_between_states = to_state.gametime - from_state.gametime;
          interpolation_percentage = (offset_time / time_between_states) * 1.0;
          if (interpolation_percentage < 0.0) {
            interpolation_percentage = 0;
          }
          if (interpolation_percentage > 1.0) {
            interpolation_percentage = 1;
          }
          this.x += Math.round((to_state.x - from_state.x) * interpolation_percentage);
          return this.y += Math.round((to_state.y - from_state.y) * interpolation_percentage);
        }
      },
      get_states_for_lerping: function(render_time) {
        var from_state, index, state, to_state, _len, _ref;
        from_state = null;
        to_state = null;
        _ref = this._received_states;
        for (index = 0, _len = _ref.length; index < _len; index++) {
          state = _ref[index];
          if (state.gametime > render_time) {
            to_state = state;
            from_state = this._received_states[index - 1];
            break;
          }
        }
        if (to_state && !from_state) {
          from_state = to_state;
        }
        return [from_state, to_state];
      }
    };
  };
}).call(this);
