exports = this

sys = require 'sys'
_   = require('underscore')

percept = require('percept')
event_emitter = percept.EventEmitter
Entity = require('./my_game_entity').MyGameEntity


exports.MyGame = class MyGame
  constructor: (@args={}) ->
    _.extend(this, new event_emitter())
    @entities_by_id = {}
    @tick = 0
    @gametime = new Date().getTime() #this gets updated with each tick
    @start_ticking()


  add_player: (id) -> 
    player = new Entity id: id 
    @entities_by_id[id] = player
    # Your game MUST emit an entity_changed event whenever an entity's state changes, if you want that to be replicated to all connected players.
    player.on 'changed', (changed_state) => @emit('entity_changed', changed_state)
    @emit 'entity_created', player
    player


  remove_player: (id) -> 
    delete @entities_by_id[id]


  start_ticking: () ->
    @tick_interval = setInterval (=> @do_tick()), (1000 / 20)


  do_tick: () ->
    @gametime = new Date().getTime()
    @emit 'tick', gametime: @gametime
