exports = this

# Ugly hack using || to use existing vars (client-side via this., which maps to window) or require them (server-side)
_             = this._ || require('underscore')
percept       = this.Percept || require('percept')
event_emitter = percept.EventEmitter


exports.MyGameEntity = class MyGameEntity
  constructor: (@args={}) ->
    _.extend(this, new event_emitter())
    @id = @args.id
    @speed = 3
    @x = @args.x? || 0
    @y = @args.y? || 0


  # PlayerCommand messages sent by players will be passed directly to the player's associated
  # entity object, so you'll probably want something to handle movement. =-)
  move: (args) ->
    switch args.dir
      when 'up'     then @y -= @speed
      when 'down'   then @y += @speed
      when 'left'   then @x -= @speed
      when 'right'  then @x += @speed

    # Entities MUST emit a changed event when they change
    @emit 'changed', entity_id: @id, entity_state: {x: @x, y: @y}


  # Entities MUST have a get_state() method that returns an object suitable for replication to connected clients
  get_state: ->
    id: @id
    x: @x
    y: @y
