(function() {
  window.requestAnimationFrame = (function() {
    return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame || (function(callback, element) {
      return window.setTimeout(callback, 1000 / 60);
    });
  })();
  window.client = {
    init: function() {
      var create_entity, destroy_entity;
      create_entity = function(id, state) {
        var e;
        e = new window.MyGameEntity();
        e.img = '/images/character_boy.png';
        _.extend(e, new Percept.Lerpable());
        e.dom_node = $("<img src='" + e.img + "'>").css({
          position: 'absolute',
          top: "" + e.x + "px",
          left: "" + e.y + "px"
        }).appendTo('body');
        return e;
      };
      destroy_entity = function(entity) {
        return $(entity.dom_node).remove();
      };
      this.percept_client = new Percept.Client({
        create_entity: create_entity,
        destroy_entity: destroy_entity
      });
      return this.input = new window.InputManager();
    },
    poll_input: function() {
      var command_id, dir, movement_keys, msg, _ref;
      this.input.update();
      movement_keys = {
        up: 87,
        down: 83,
        left: 65,
        right: 68
      };
      dir = null;
      if (this.input.isKeyDown(movement_keys.up)) {
        dir = 'up';
      }
      if (this.input.isKeyDown(movement_keys.down)) {
        dir = 'down';
      }
      if (this.input.isKeyDown(movement_keys.left)) {
        dir = 'left';
      }
      if (this.input.isKeyDown(movement_keys.right)) {
        dir = 'right';
      }
      if (dir != null) {
        _ref = [this.percept_client.next_player_command_id, this.percept_client.next_player_command_id + 1], command_id = _ref[0], this.percept_client.next_player_command_id = _ref[1];
        msg = new Percept.Message({
          message_type: Percept.Message.MESSAGE_TYPES.PLAYER_COMMAND,
          command: 'move',
          command_id: command_id,
          args: {
            dir: dir
          }
        });
        this.percept_client.unacknowledged_player_commands.push(msg);
        return this.percept_client.send_message(msg);
      }
    },
    redraw_entities: function() {
      var e, id, _ref, _results;
      _ref = this.percept_client.entities_by_id;
      _results = [];
      for (id in _ref) {
        e = _ref[id];
        _results.push($(e.dom_node).css({
          top: e.y,
          left: e.x
        }));
      }
      return _results;
    }
  };
  window.render_frame = function(time) {
    window.requestAnimationFrame(render_frame);
    window.client.poll_input();
    window.client.percept_client.new_frame();
    return window.client.redraw_entities();
  };
  $(function() {
    window.client.init();
    return window.render_frame();
  });
}).call(this);
