(function() {
  var Entity, MyGame, event_emitter, exports, percept, sys, _;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  exports = this;
  sys = require('sys');
  _ = require('underscore');
  percept = require('percept');
  event_emitter = percept.EventEmitter;
  Entity = require('./my_game_entity').MyGameEntity;
  exports.MyGame = MyGame = (function() {
    function MyGame(args) {
      this.args = args != null ? args : {};
      _.extend(this, new event_emitter());
      this.entities_by_id = {};
      this.tick = 0;
      this.gametime = new Date().getTime();
      this.start_ticking();
    }
    MyGame.prototype.add_player = function(id) {
      var player;
      player = new Entity({
        id: id
      });
      this.entities_by_id[id] = player;
      player.on('changed', __bind(function(changed_state) {
        return this.emit('entity_changed', changed_state);
      }, this));
      this.emit('entity_created', player);
      return player;
    };
    MyGame.prototype.remove_player = function(id) {
      return delete this.entities_by_id[id];
    };
    MyGame.prototype.start_ticking = function() {
      return this.tick_interval = setInterval((__bind(function() {
        return this.do_tick();
      }, this)), 1000 / 20);
    };
    MyGame.prototype.do_tick = function() {
      this.gametime = new Date().getTime();
      return this.emit('tick', {
        gametime: this.gametime
      });
    };
    return MyGame;
  })();
}).call(this);
