exports = this
InputManager = ->
  @keyState = []
  @keyCurrent = []
  @keyLast = []
  self = this
  window.addEventListener "keydown", (ev) ->
    self.keyCurrent[ev.which] = true
    self.keyState[ev.which] = true
  
  window.addEventListener "keyup", (ev) ->
    self.keyState[ev.which] = false

InputManager::update = ->
  #call update() once per run of the game's logic update (render loop)
  @keyLast = @keyCurrent
  @keyCurrent = @keyState.slice(0)

InputManager::isKeyDown = (key) ->
  !!@keyCurrent[key]

InputManager::isKeyTriggered = (key) ->
  !!@keyCurrent[key] and not @keyLast[key]

InputManager::isKeyReleased = (key) ->
  not @keyCurrent[key] and !!@keyLast[key]

exports.InputManager = InputManager
