exports = this

exports.Lerpable = ->
  _received_states: []

  # Perform linerar interpolation to update entity relative to render_time 
  lerp_update: (render_time) ->
    [from_state, to_state] = @get_states_for_lerping(render_time)
    self = this

    # Start us out at last known from_state
    self[prop] = val for prop, val of from_state

    # Don't lerp if we dont have states to lerp between, meaning this method was called on an entity that has no changes at this render_time.
    unless from_state? and to_state?
      return 

    # Don't interpolate if the distance is too great
    max_interpolation_distance = 300 #TODO base this on entity's speed?
    distance_xy = [Math.abs(to_state.x - from_state.x), Math.abs(to_state.y - from_state.y)]
    distance_too_great = true if distance_xy[0] > max_interpolation_distance || distance_xy[1] > max_interpolation_distance

    dont_interpolate = true if distance_too_great
    # Calculate how far along into the interpolated state we are
    if dont_interpolate
      interpolation_percentage = 1.0
    else
      # What's our time relative to the previous state?
      offset_time = render_time - from_state.gametime

      # What's the time between states?
      time_between_states = to_state.gametime - from_state.gametime

      interpolation_percentage = (offset_time / time_between_states) * 1.0
      interpolation_percentage = 0 if interpolation_percentage < 0.0
      interpolation_percentage = 1 if interpolation_percentage > 1.0

      # OK. Now we want to linearly interpolate the entity's x and y relative to the interpolation_percentage
      @x += Math.round((to_state.x - from_state.x) * interpolation_percentage)
      @y += Math.round((to_state.y - from_state.y) * interpolation_percentage)



  get_states_for_lerping: (render_time) ->
    from_state = null
    to_state = null

    for state, index in @_received_states
      if state.gametime > render_time
        # Found the first state that's past now, so use this one and the one before since they straddle the render time
        to_state = state
        from_state = @_received_states[index - 1]
        break

    from_state = to_state if to_state and not from_state
    return [from_state, to_state]
